<?php
session_start(); // Initialize Session data
ob_start(); // Turn on output buffering
?>
<?php include "ewcfg7.php" ?>
<?php include "ewmysql7.php" ?>
<?php include "phpfn7.php" ?>
<?php include "tbl_travelinfo.php" ?>
<?php include "tbl_languageinfo.php" ?>
<?php include "tbl_travel_originalinfo.php" ?>
<?php include "tbl_admininfo.php" ?>
<?php include "userfn7.php" ?>
<?php
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT"); // Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // Always modified
header("Cache-Control: private, no-store, no-cache, must-revalidate"); // HTTP/1.1 
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache"); // HTTP/1.0
?>
<?php

// Create page object
$tbl_travel_add = new ctbl_travel_add();
$Page =& $tbl_travel_add;

// Page init
$tbl_travel_add->Page_Init();

// Page main
$tbl_travel_add->Page_Main();
?>
<?php include "header.php" ?>
<script type="text/javascript">
<!--

// Create page object
var tbl_travel_add = new ew_Page("tbl_travel_add");

// page properties
tbl_travel_add.PageID = "add"; // page ID
tbl_travel_add.FormID = "ftbl_traveladd"; // form ID
var EW_PAGE_ID = tbl_travel_add.PageID; // for backward compatibility

// extend page with ValidateForm function
tbl_travel_add.ValidateForm = function(fobj) {
	ew_PostAutoSuggest(fobj);
	if (!this.ValidateRequired)
		return true; // ignore validation
	if (fobj.a_confirm && fobj.a_confirm.value == "F")
		return true;
	var i, elm, aelm, infix;
	var rowcnt = (fobj.key_count) ? Number(fobj.key_count.value) : 1;
	for (i=0; i<rowcnt; i++) {
		infix = (fobj.key_count) ? String(i+1) : "";
		elm = fobj.elements["x" + infix + "_travel_or_id"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($tbl_travel->travel_or_id->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_photo"];
		aelm = fobj.elements["a" + infix + "_photo"];
		var chk_photo = (aelm && aelm[0])?(aelm[2].checked):true;
		if (elm && chk_photo && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($tbl_travel->photo->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_photo"];
		if (elm && !ew_CheckFileType(elm.value))
			return ew_OnError(this, elm, ewLanguage.Phrase("WrongFileType"));
		elm = fobj.elements["x" + infix + "_language_id"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($tbl_travel->language_id->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_category"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($tbl_travel->category->FldCaption()) ?>");
		elm = fobj.elements["x" + infix + "_description"];
		if (elm && !ew_HasValue(elm))
			return ew_OnError(this, elm, ewLanguage.Phrase("EnterRequiredField") + " - <?php echo ew_JsEncode2($tbl_travel->description->FldCaption()) ?>");

		// Call Form Custom Validate event
		if (!this.Form_CustomValidate(fobj)) return false;
	}
	return true;
}

// extend page with Form_CustomValidate function
tbl_travel_add.Form_CustomValidate =  
 function(fobj) { // DO NOT CHANGE THIS LINE!

 	// Your custom validation code here, return false if invalid. 
 	return true;
 }
<?php if (EW_CLIENT_VALIDATE) { ?>
tbl_travel_add.ValidateRequired = true; // uses JavaScript validation
<?php } else { ?>
tbl_travel_add.ValidateRequired = false; // no JavaScript validation
<?php } ?>

//-->
</script>
<script type="text/javascript" src="fckeditor/fckeditor.js"></script>
<script type="text/javascript">
<!--
_width_multiplier = 16;
_height_multiplier = 60;
var ew_DHTMLEditors = [];

// update value from editor to textarea
function ew_UpdateTextArea() {
	if (typeof ew_DHTMLEditors != 'undefined' && typeof FCKeditorAPI != 'undefined') {			
			var inst;			
			for (inst in FCKeditorAPI.__Instances)
				FCKeditorAPI.__Instances[inst].UpdateLinkedField();
	}
}

// update value from textarea to editor
function ew_UpdateDHTMLEditor(name) {
	if (typeof ew_DHTMLEditors != 'undefined' && typeof FCKeditorAPI != 'undefined') {
		var inst = FCKeditorAPI.GetInstance(name);		
		if (inst)
			inst.SetHTML(inst.LinkedField.value)
	}
}

// focus editor
function ew_FocusDHTMLEditor(name) {
	if (typeof ew_DHTMLEditors != 'undefined' && typeof FCKeditorAPI != 'undefined') {
		var inst = FCKeditorAPI.GetInstance(name);	
		if (inst && inst.EditorWindow) {
			inst.EditorWindow.focus();
		}
	}
}

//-->
</script>
<script language="JavaScript" type="text/javascript">
<!--

// Write your client script here, no need to add script tags.
// To include another .js script, use:
// ew_ClientScriptInclude("my_javascript.js"); 
//-->

</script>
<p><span class="phpmaker"><?php echo $Language->Phrase("Add") ?>&nbsp;<?php echo $Language->Phrase("TblTypeTABLE") ?><?php echo $tbl_travel->TableCaption() ?><br><br>
<a href="<?php echo $tbl_travel->getReturnUrl() ?>"><?php echo $Language->Phrase("GoBack") ?></a></span></p>
<?php
if (EW_DEBUG_ENABLED)
	echo ew_DebugMsg();
$tbl_travel_add->ShowMessage();
?>
<form name="ftbl_traveladd" id="ftbl_traveladd" action="<?php echo ew_CurrentPage() ?>" method="post" enctype="multipart/form-data">
<p>
<input type="hidden" name="t" id="t" value="tbl_travel">
<input type="hidden" name="a_add" id="a_add" value="A">
<table cellspacing="0" class="ewGrid"><tr><td class="ewGridContent">
<div class="ewGridMiddlePanel">
<table cellspacing="0" class="ewTable">
<?php if ($tbl_travel->travel_or_id->Visible) { // travel_or_id ?>
	<tr<?php echo $tbl_travel->RowAttributes() ?>>
		<td class="ewTableHeader"><?php echo $tbl_travel->travel_or_id->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td>
		<td<?php echo $tbl_travel->travel_or_id->CellAttributes() ?>><span id="el_travel_or_id">
<?php if ($tbl_travel->travel_or_id->getSessionValue() <> "") { ?>
<div<?php echo $tbl_travel->travel_or_id->ViewAttributes() ?>><?php echo $tbl_travel->travel_or_id->ViewValue ?></div>
<input type="hidden" id="x_travel_or_id" name="x_travel_or_id" value="<?php echo ew_HtmlEncode($tbl_travel->travel_or_id->CurrentValue) ?>">
<?php } else { ?>
<select id="x_travel_or_id" name="x_travel_or_id" title="<?php echo $tbl_travel->travel_or_id->FldTitle() ?>"<?php echo $tbl_travel->travel_or_id->EditAttributes() ?>>
<?php
if (is_array($tbl_travel->travel_or_id->EditValue)) {
	$arwrk = $tbl_travel->travel_or_id->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = (strval($tbl_travel->travel_or_id->CurrentValue) == strval($arwrk[$rowcntwrk][0])) ? " selected=\"selected\"" : "";
		if ($selwrk <> "") $emptywrk = FALSE;
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $arwrk[$rowcntwrk][1] ?>
</option>
<?php
	}
}
?>
</select>
<?php
$sSqlWrk = "SELECT `travel_or_id`, `name`, '' AS Disp2Fld FROM `tbl_travel_original`";
$sWhereWrk = "";
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
$sSqlWrk = TEAencrypt($sSqlWrk, EW_RANDOM_KEY);
?>
<input type="hidden" name="s_x_travel_or_id" id="s_x_travel_or_id" value="<?php echo $sSqlWrk; ?>">
<input type="hidden" name="lft_x_travel_or_id" id="lft_x_travel_or_id" value="">
<?php } ?>
</span><?php echo $tbl_travel->travel_or_id->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($tbl_travel->photo->Visible) { // photo ?>
	<tr<?php echo $tbl_travel->RowAttributes() ?>>
		<td class="ewTableHeader"><?php echo $tbl_travel->photo->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td>
		<td<?php echo $tbl_travel->photo->CellAttributes() ?>><span id="el_photo">
<input type="file" name="x_photo" id="x_photo" title="<?php echo $tbl_travel->photo->FldTitle() ?>" size="75"<?php echo $tbl_travel->photo->EditAttributes() ?>>
</div>
</span><?php echo $tbl_travel->photo->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($tbl_travel->language_id->Visible) { // language_id ?>
	<tr<?php echo $tbl_travel->RowAttributes() ?>>
		<td class="ewTableHeader"><?php echo $tbl_travel->language_id->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td>
		<td<?php echo $tbl_travel->language_id->CellAttributes() ?>><span id="el_language_id">
<?php if ($tbl_travel->language_id->getSessionValue() <> "") { ?>
<div<?php echo $tbl_travel->language_id->ViewAttributes() ?>><?php echo $tbl_travel->language_id->ViewValue ?></div>
<input type="hidden" id="x_language_id" name="x_language_id" value="<?php echo ew_HtmlEncode($tbl_travel->language_id->CurrentValue) ?>">
<?php } else { ?>
<select id="x_language_id" name="x_language_id" title="<?php echo $tbl_travel->language_id->FldTitle() ?>"<?php echo $tbl_travel->language_id->EditAttributes() ?>>
<?php
if (is_array($tbl_travel->language_id->EditValue)) {
	$arwrk = $tbl_travel->language_id->EditValue;
	$rowswrk = count($arwrk);
	$emptywrk = TRUE;
	for ($rowcntwrk = 0; $rowcntwrk < $rowswrk; $rowcntwrk++) {
		$selwrk = (strval($tbl_travel->language_id->CurrentValue) == strval($arwrk[$rowcntwrk][0])) ? " selected=\"selected\"" : "";
		if ($selwrk <> "") $emptywrk = FALSE;
?>
<option value="<?php echo ew_HtmlEncode($arwrk[$rowcntwrk][0]) ?>"<?php echo $selwrk ?>>
<?php echo $arwrk[$rowcntwrk][1] ?>
</option>
<?php
	}
}
?>
</select>
<?php
$sSqlWrk = "SELECT DISTINCT `language_id`, `language`, '' AS Disp2Fld FROM `tbl_language`";
$sWhereWrk = "";
if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
$sSqlWrk = TEAencrypt($sSqlWrk, EW_RANDOM_KEY);
?>
<input type="hidden" name="s_x_language_id" id="s_x_language_id" value="<?php echo $sSqlWrk; ?>">
<input type="hidden" name="lft_x_language_id" id="lft_x_language_id" value="">
<?php } ?>
</span><?php echo $tbl_travel->language_id->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($tbl_travel->category->Visible) { // category ?>
	<tr<?php echo $tbl_travel->RowAttributes() ?>>
		<td class="ewTableHeader"><?php echo $tbl_travel->category->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td>
		<td<?php echo $tbl_travel->category->CellAttributes() ?>><span id="el_category">
<input type="text" name="x_category" id="x_category" title="<?php echo $tbl_travel->category->FldTitle() ?>" size="75" maxlength="100" value="<?php echo $tbl_travel->category->EditValue ?>"<?php echo $tbl_travel->category->EditAttributes() ?>>
</span><?php echo $tbl_travel->category->CustomMsg ?></td>
	</tr>
<?php } ?>
<?php if ($tbl_travel->description->Visible) { // description ?>
	<tr<?php echo $tbl_travel->RowAttributes() ?>>
		<td class="ewTableHeader"><?php echo $tbl_travel->description->FldCaption() ?><?php echo $Language->Phrase("FieldRequiredIndicator") ?></td>
		<td<?php echo $tbl_travel->description->CellAttributes() ?>><span id="el_description">
<textarea name="x_description" id="x_description" title="<?php echo $tbl_travel->description->FldTitle() ?>" cols="35" rows="7"<?php echo $tbl_travel->description->EditAttributes() ?>><?php echo $tbl_travel->description->EditValue ?></textarea>
<script type="text/javascript">
<!--
ew_DHTMLEditors.push(new ew_DHTMLEditor("x_description", function() {
	var sBasePath = 'fckeditor/';
	var oFCKeditor = new FCKeditor('x_description', 35*_width_multiplier, 7*_height_multiplier);
	oFCKeditor.BasePath = sBasePath;
	oFCKeditor.ReplaceTextarea();
	this.active = true;
}));
-->
</script>
</span><?php echo $tbl_travel->description->CustomMsg ?></td>
	</tr>
<?php } ?>
</table>
</div>
</td></tr></table>
<p>
<input type="button" name="btnAction" id="btnAction" value="<?php echo ew_BtnCaption($Language->Phrase("AddBtn")) ?>" onclick="ew_SubmitForm(tbl_travel_add, this.form);">
</form>
<script language="JavaScript" type="text/javascript">
<!--
ew_UpdateOpts([['x_travel_or_id','x_travel_or_id',false],
['x_language_id','x_language_id',false]]);

//-->
</script>
<script type="text/javascript">
<!--
ew_CreateEditor();  // Create DHTML editor(s)

//-->
</script>
<script language="JavaScript" type="text/javascript">
<!--

// Write your table-specific startup script here
// document.write("page loaded");
//-->

</script>
<?php include "footer.php" ?>
<?php
$tbl_travel_add->Page_Terminate();
?>
<?php

//
// Page class
//
class ctbl_travel_add {

	// Page ID
	var $PageID = 'add';

	// Table name
	var $TableName = 'tbl_travel';

	// Page object name
	var $PageObjName = 'tbl_travel_add';

	// Page name
	function PageName() {
		return ew_CurrentPage();
	}

	// Page URL
	function PageUrl() {
		$PageUrl = ew_CurrentPage() . "?";
		global $tbl_travel;
		if ($tbl_travel->UseTokenInUrl) $PageUrl .= "t=" . $tbl_travel->TableVar . "&"; // Add page token
		return $PageUrl;
	}

	// Page URLs
	var $AddUrl;
	var $EditUrl;
	var $CopyUrl;
	var $DeleteUrl;
	var $ViewUrl;
	var $ListUrl;

	// Export URLs
	var $ExportPrintUrl;
	var $ExportHtmlUrl;
	var $ExportExcelUrl;
	var $ExportWordUrl;
	var $ExportXmlUrl;
	var $ExportCsvUrl;

	// Update URLs
	var $InlineAddUrl;
	var $InlineCopyUrl;
	var $InlineEditUrl;
	var $GridAddUrl;
	var $GridEditUrl;
	var $MultiDeleteUrl;
	var $MultiUpdateUrl;

	// Message
	function getMessage() {
		return @$_SESSION[EW_SESSION_MESSAGE];
	}

	function setMessage($v) {
		if (@$_SESSION[EW_SESSION_MESSAGE] <> "") { // Append
			$_SESSION[EW_SESSION_MESSAGE] .= "<br>" . $v;
		} else {
			$_SESSION[EW_SESSION_MESSAGE] = $v;
		}
	}

	// Show message
	function ShowMessage() {
		$sMessage = $this->getMessage();
		$this->Message_Showing($sMessage);
		if ($sMessage <> "") { // Message in Session, display
			echo "<p><span class=\"ewMessage\">" . $sMessage . "</span></p>";
			$_SESSION[EW_SESSION_MESSAGE] = ""; // Clear message in Session
		}
	}

	// Validate page request
	function IsPageRequest() {
		global $objForm, $tbl_travel;
		if ($tbl_travel->UseTokenInUrl) {
			if ($objForm)
				return ($tbl_travel->TableVar == $objForm->GetValue("t"));
			if (@$_GET["t"] <> "")
				return ($tbl_travel->TableVar == $_GET["t"]);
		} else {
			return TRUE;
		}
	}

	//
	// Page class constructor
	//
	function ctbl_travel_add() {
		global $conn, $Language;

		// Language object
		$Language = new cLanguage();

		// Table object (tbl_travel)
		$GLOBALS["tbl_travel"] = new ctbl_travel();

		// Table object (tbl_language)
		$GLOBALS['tbl_language'] = new ctbl_language();

		// Table object (tbl_travel_original)
		$GLOBALS['tbl_travel_original'] = new ctbl_travel_original();

		// Table object (tbl_admin)
		$GLOBALS['tbl_admin'] = new ctbl_admin();

		// Page ID
		if (!defined("EW_PAGE_ID"))
			define("EW_PAGE_ID", 'add', TRUE);

		// Table name (for backward compatibility)
		if (!defined("EW_TABLE_NAME"))
			define("EW_TABLE_NAME", 'tbl_travel', TRUE);

		// Start timer
		$GLOBALS["gsTimer"] = new cTimer();

		// Open connection
		$conn = ew_Connect();
	}

	// 
	//  Page_Init
	//
	function Page_Init() {
		global $gsExport, $gsExportFile, $UserProfile, $Language, $Security, $objForm;
		global $tbl_travel;

		// Security
		$Security = new cAdvancedSecurity();
		if (!$Security->IsLoggedIn()) $Security->AutoLogin();
		if (!$Security->IsLoggedIn()) {
			$Security->SaveLastUrl();
			$this->Page_Terminate("login.php");
		}

		// Create form object
		$objForm = new cFormObj();

		// Global Page Loading event (in userfn*.php)
		Page_Loading();

		// Page Load event
		$this->Page_Load();
	}

	//
	// Page_Terminate
	//
	function Page_Terminate($url = "") {
		global $conn;

		// Page Unload event
		$this->Page_Unload();

		// Global Page Unloaded event (in userfn*.php)
		Page_Unloaded();

		 // Close connection
		$conn->Close();

		// Go to URL if specified
		$this->Page_Redirecting($url);
		if ($url <> "") {
			if (!EW_DEBUG_ENABLED && ob_get_length())
				ob_end_clean();
			header("Location: " . $url);
		}
		exit();
	}
	var $sDbMasterFilter = "";
	var $sDbDetailFilter = "";
	var $lPriv = 0;

	// 
	// Page main
	//
	function Page_Main() {
		global $objForm, $Language, $gsFormError, $tbl_travel;

		// Load key values from QueryString
		$bCopy = TRUE;
		if (@$_GET["travel_id"] != "") {
		  $tbl_travel->travel_id->setQueryStringValue($_GET["travel_id"]);
		} else {
		  $bCopy = FALSE;
		}

		// Set up master/detail parameters
		$this->SetUpMasterDetail();

		// Process form if post back
		if (@$_POST["a_add"] <> "") {
		   $tbl_travel->CurrentAction = $_POST["a_add"]; // Get form action
		  $this->GetUploadFiles(); // Get upload files
		  $this->LoadFormValues(); // Load form values

			// Validate form
			if (!$this->ValidateForm()) {
				$tbl_travel->CurrentAction = "I"; // Form error, reset action
				$this->setMessage($gsFormError);
			}
		} else { // Not post back
		  if ($bCopy) {
		    $tbl_travel->CurrentAction = "C"; // Copy record
		  } else {
		    $tbl_travel->CurrentAction = "I"; // Display blank record
		    $this->LoadDefaultValues(); // Load default values
		  }
		}

		// Perform action based on action code
		switch ($tbl_travel->CurrentAction) {
		  case "I": // Blank record, no action required
				break;
		  case "C": // Copy an existing record
		   if (!$this->LoadRow()) { // Load record based on key
		      $this->setMessage($Language->Phrase("NoRecord")); // No record found
		      $this->Page_Terminate("tbl_travellist.php"); // No matching record, return to list
		    }
				break;
		  case "A": // ' Add new record
				$tbl_travel->SendEmail = TRUE; // Send email on add success
		    if ($this->AddRow()) { // Add successful
		      $this->setMessage($Language->Phrase("AddSuccess")); // Set up success message
					$sReturnUrl = $tbl_travel->getReturnUrl();
					$this->Page_Terminate($sReturnUrl); // Clean up and return
		    } else {
		      $this->RestoreFormValues(); // Add failed, restore form values
		    }
		}

		// Render row based on row type
		$tbl_travel->RowType = EW_ROWTYPE_ADD;  // Render add type

		// Render row
		$this->RenderRow();
	}

	// Get upload files
	function GetUploadFiles() {
		global $objForm, $tbl_travel;

		// Get upload data
			if ($tbl_travel->photo->Upload->UploadFile()) {

				// No action required
			} else {
				echo $tbl_travel->photo->Upload->Message;
				$this->Page_Terminate();
				exit();
			}
	}

	// Load default values
	function LoadDefaultValues() {
		global $tbl_travel;
		$tbl_travel->photo->CurrentValue = NULL; // Clear file related field
	}

	// Load form values
	function LoadFormValues() {

		// Load from form
		global $objForm, $tbl_travel;
		$tbl_travel->travel_or_id->setFormValue($objForm->GetValue("x_travel_or_id"));
		$tbl_travel->language_id->setFormValue($objForm->GetValue("x_language_id"));
		$tbl_travel->category->setFormValue($objForm->GetValue("x_category"));
		$tbl_travel->description->setFormValue($objForm->GetValue("x_description"));
		$tbl_travel->travel_id->setFormValue($objForm->GetValue("x_travel_id"));
	}

	// Restore form values
	function RestoreFormValues() {
		global $objForm, $tbl_travel;
		$tbl_travel->travel_id->CurrentValue = $tbl_travel->travel_id->FormValue;
		$tbl_travel->travel_or_id->CurrentValue = $tbl_travel->travel_or_id->FormValue;
		$tbl_travel->language_id->CurrentValue = $tbl_travel->language_id->FormValue;
		$tbl_travel->category->CurrentValue = $tbl_travel->category->FormValue;
		$tbl_travel->description->CurrentValue = $tbl_travel->description->FormValue;
	}

	// Load row based on key values
	function LoadRow() {
		global $conn, $Security, $tbl_travel;
		$sFilter = $tbl_travel->KeyFilter();

		// Call Row Selecting event
		$tbl_travel->Row_Selecting($sFilter);

		// Load SQL based on filter
		$tbl_travel->CurrentFilter = $sFilter;
		$sSql = $tbl_travel->SQL();
		$res = FALSE;
		$rs = ew_LoadRecordset($sSql);
		if ($rs && !$rs->EOF) {
			$res = TRUE;
			$this->LoadRowValues($rs); // Load row values

			// Call Row Selected event
			$tbl_travel->Row_Selected($rs);
			$rs->Close();
		}
		return $res;
	}

	// Load row values from recordset
	function LoadRowValues(&$rs) {
		global $conn, $tbl_travel;
		$tbl_travel->travel_id->setDbValue($rs->fields('travel_id'));
		$tbl_travel->travel_or_id->setDbValue($rs->fields('travel_or_id'));
		$tbl_travel->photo->Upload->DbValue = $rs->fields('photo');
		$tbl_travel->language_id->setDbValue($rs->fields('language_id'));
		$tbl_travel->category->setDbValue($rs->fields('category'));
		$tbl_travel->description->setDbValue($rs->fields('description'));
	}

	// Render row values based on field settings
	function RenderRow() {
		global $conn, $Security, $Language, $tbl_travel;

		// Initialize URLs
		// Call Row_Rendering event

		$tbl_travel->Row_Rendering();

		// Common render codes for all row types
		// travel_or_id

		$tbl_travel->travel_or_id->CellCssStyle = ""; $tbl_travel->travel_or_id->CellCssClass = "";
		$tbl_travel->travel_or_id->CellAttrs = array(); $tbl_travel->travel_or_id->ViewAttrs = array(); $tbl_travel->travel_or_id->EditAttrs = array();

		// photo
		$tbl_travel->photo->CellCssStyle = ""; $tbl_travel->photo->CellCssClass = "";
		$tbl_travel->photo->CellAttrs = array(); $tbl_travel->photo->ViewAttrs = array(); $tbl_travel->photo->EditAttrs = array();

		// language_id
		$tbl_travel->language_id->CellCssStyle = ""; $tbl_travel->language_id->CellCssClass = "";
		$tbl_travel->language_id->CellAttrs = array(); $tbl_travel->language_id->ViewAttrs = array(); $tbl_travel->language_id->EditAttrs = array();

		// category
		$tbl_travel->category->CellCssStyle = ""; $tbl_travel->category->CellCssClass = "";
		$tbl_travel->category->CellAttrs = array(); $tbl_travel->category->ViewAttrs = array(); $tbl_travel->category->EditAttrs = array();

		// description
		$tbl_travel->description->CellCssStyle = ""; $tbl_travel->description->CellCssClass = "";
		$tbl_travel->description->CellAttrs = array(); $tbl_travel->description->ViewAttrs = array(); $tbl_travel->description->EditAttrs = array();
		if ($tbl_travel->RowType == EW_ROWTYPE_VIEW) { // View row

			// travel_id
			$tbl_travel->travel_id->ViewValue = $tbl_travel->travel_id->CurrentValue;
			$tbl_travel->travel_id->CssStyle = "";
			$tbl_travel->travel_id->CssClass = "";
			$tbl_travel->travel_id->ViewCustomAttributes = "";

			// travel_or_id
			if (strval($tbl_travel->travel_or_id->CurrentValue) <> "") {
				$sFilterWrk = "`travel_or_id` = " . ew_AdjustSql($tbl_travel->travel_or_id->CurrentValue) . "";
			$sSqlWrk = "SELECT `name` FROM `tbl_travel_original`";
			$sWhereWrk = "";
			if ($sFilterWrk <> "") {
				if ($sWhereWrk <> "") $sWhereWrk .= " AND ";
				$sWhereWrk .= "(" . $sFilterWrk . ")";
			}
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
				$rswrk = $conn->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$tbl_travel->travel_or_id->ViewValue = $rswrk->fields('name');
					$rswrk->Close();
				} else {
					$tbl_travel->travel_or_id->ViewValue = $tbl_travel->travel_or_id->CurrentValue;
				}
			} else {
				$tbl_travel->travel_or_id->ViewValue = NULL;
			}
			$tbl_travel->travel_or_id->CssStyle = "";
			$tbl_travel->travel_or_id->CssClass = "";
			$tbl_travel->travel_or_id->ViewCustomAttributes = "";

			// photo
			if (!ew_Empty($tbl_travel->photo->Upload->DbValue)) {
				$tbl_travel->photo->ViewValue = $tbl_travel->photo->Upload->DbValue;
				$tbl_travel->photo->ImageWidth = 200;
				$tbl_travel->photo->ImageHeight = 0;
				$tbl_travel->photo->ImageAlt = $tbl_travel->photo->FldAlt();
			} else {
				$tbl_travel->photo->ViewValue = "";
			}
			$tbl_travel->photo->CssStyle = "";
			$tbl_travel->photo->CssClass = "";
			$tbl_travel->photo->ViewCustomAttributes = "";

			// language_id
			if (strval($tbl_travel->language_id->CurrentValue) <> "") {
				$sFilterWrk = "`language_id` = " . ew_AdjustSql($tbl_travel->language_id->CurrentValue) . "";
			$sSqlWrk = "SELECT DISTINCT `language` FROM `tbl_language`";
			$sWhereWrk = "";
			if ($sFilterWrk <> "") {
				if ($sWhereWrk <> "") $sWhereWrk .= " AND ";
				$sWhereWrk .= "(" . $sFilterWrk . ")";
			}
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
				$rswrk = $conn->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$tbl_travel->language_id->ViewValue = $rswrk->fields('language');
					$rswrk->Close();
				} else {
					$tbl_travel->language_id->ViewValue = $tbl_travel->language_id->CurrentValue;
				}
			} else {
				$tbl_travel->language_id->ViewValue = NULL;
			}
			$tbl_travel->language_id->CssStyle = "";
			$tbl_travel->language_id->CssClass = "";
			$tbl_travel->language_id->ViewCustomAttributes = "";

			// category
			$tbl_travel->category->ViewValue = $tbl_travel->category->CurrentValue;
			$tbl_travel->category->CssStyle = "";
			$tbl_travel->category->CssClass = "";
			$tbl_travel->category->ViewCustomAttributes = "";

			// description
			$tbl_travel->description->ViewValue = $tbl_travel->description->CurrentValue;
			$tbl_travel->description->CssStyle = "";
			$tbl_travel->description->CssClass = "";
			$tbl_travel->description->ViewCustomAttributes = "";

			// travel_or_id
			$tbl_travel->travel_or_id->HrefValue = "";
			$tbl_travel->travel_or_id->TooltipValue = "";

			// photo
			$tbl_travel->photo->HrefValue = "";
			$tbl_travel->photo->TooltipValue = "";

			// language_id
			$tbl_travel->language_id->HrefValue = "";
			$tbl_travel->language_id->TooltipValue = "";

			// category
			$tbl_travel->category->HrefValue = "";
			$tbl_travel->category->TooltipValue = "";

			// description
			$tbl_travel->description->HrefValue = "";
			$tbl_travel->description->TooltipValue = "";
		} elseif ($tbl_travel->RowType == EW_ROWTYPE_ADD) { // Add row

			// travel_or_id
			$tbl_travel->travel_or_id->EditCustomAttributes = "";
			if ($tbl_travel->travel_or_id->getSessionValue() <> "") {
				$tbl_travel->travel_or_id->CurrentValue = $tbl_travel->travel_or_id->getSessionValue();
			if (strval($tbl_travel->travel_or_id->CurrentValue) <> "") {
				$sFilterWrk = "`travel_or_id` = " . ew_AdjustSql($tbl_travel->travel_or_id->CurrentValue) . "";
			$sSqlWrk = "SELECT `name` FROM `tbl_travel_original`";
			$sWhereWrk = "";
			if ($sFilterWrk <> "") {
				if ($sWhereWrk <> "") $sWhereWrk .= " AND ";
				$sWhereWrk .= "(" . $sFilterWrk . ")";
			}
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
				$rswrk = $conn->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$tbl_travel->travel_or_id->ViewValue = $rswrk->fields('name');
					$rswrk->Close();
				} else {
					$tbl_travel->travel_or_id->ViewValue = $tbl_travel->travel_or_id->CurrentValue;
				}
			} else {
				$tbl_travel->travel_or_id->ViewValue = NULL;
			}
			$tbl_travel->travel_or_id->CssStyle = "";
			$tbl_travel->travel_or_id->CssClass = "";
			$tbl_travel->travel_or_id->ViewCustomAttributes = "";
			} else {
			if (trim(strval($tbl_travel->travel_or_id->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`travel_or_id` = " . ew_AdjustSql($tbl_travel->travel_or_id->CurrentValue) . "";
			}
			$sSqlWrk = "SELECT `travel_or_id`, `name`, '' AS Disp2Fld, '' AS SelectFilterFld FROM `tbl_travel_original`";
			$sWhereWrk = "";
			if ($sFilterWrk <> "") {
				if ($sWhereWrk <> "") $sWhereWrk .= " AND ";
				$sWhereWrk .= "(" . $sFilterWrk . ")";
			}
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = $conn->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect")));
			$tbl_travel->travel_or_id->EditValue = $arwrk;
			}

			// photo
			$tbl_travel->photo->EditCustomAttributes = "";
			if (!ew_Empty($tbl_travel->photo->Upload->DbValue)) {
				$tbl_travel->photo->EditValue = $tbl_travel->photo->Upload->DbValue;
				$tbl_travel->photo->ImageWidth = 200;
				$tbl_travel->photo->ImageHeight = 0;
				$tbl_travel->photo->ImageAlt = $tbl_travel->photo->FldAlt();
			} else {
				$tbl_travel->photo->EditValue = "";
			}

			// language_id
			$tbl_travel->language_id->EditCustomAttributes = "";
			if ($tbl_travel->language_id->getSessionValue() <> "") {
				$tbl_travel->language_id->CurrentValue = $tbl_travel->language_id->getSessionValue();
			if (strval($tbl_travel->language_id->CurrentValue) <> "") {
				$sFilterWrk = "`language_id` = " . ew_AdjustSql($tbl_travel->language_id->CurrentValue) . "";
			$sSqlWrk = "SELECT DISTINCT `language` FROM `tbl_language`";
			$sWhereWrk = "";
			if ($sFilterWrk <> "") {
				if ($sWhereWrk <> "") $sWhereWrk .= " AND ";
				$sWhereWrk .= "(" . $sFilterWrk . ")";
			}
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
				$rswrk = $conn->Execute($sSqlWrk);
				if ($rswrk && !$rswrk->EOF) { // Lookup values found
					$tbl_travel->language_id->ViewValue = $rswrk->fields('language');
					$rswrk->Close();
				} else {
					$tbl_travel->language_id->ViewValue = $tbl_travel->language_id->CurrentValue;
				}
			} else {
				$tbl_travel->language_id->ViewValue = NULL;
			}
			$tbl_travel->language_id->CssStyle = "";
			$tbl_travel->language_id->CssClass = "";
			$tbl_travel->language_id->ViewCustomAttributes = "";
			} else {
			if (trim(strval($tbl_travel->language_id->CurrentValue)) == "") {
				$sFilterWrk = "0=1";
			} else {
				$sFilterWrk = "`language_id` = " . ew_AdjustSql($tbl_travel->language_id->CurrentValue) . "";
			}
			$sSqlWrk = "SELECT DISTINCT `language_id`, `language`, '' AS Disp2Fld, '' AS SelectFilterFld FROM `tbl_language`";
			$sWhereWrk = "";
			if ($sFilterWrk <> "") {
				if ($sWhereWrk <> "") $sWhereWrk .= " AND ";
				$sWhereWrk .= "(" . $sFilterWrk . ")";
			}
			if ($sWhereWrk <> "") $sSqlWrk .= " WHERE " . $sWhereWrk;
			$rswrk = $conn->Execute($sSqlWrk);
			$arwrk = ($rswrk) ? $rswrk->GetRows() : array();
			if ($rswrk) $rswrk->Close();
			array_unshift($arwrk, array("", $Language->Phrase("PleaseSelect")));
			$tbl_travel->language_id->EditValue = $arwrk;
			}

			// category
			$tbl_travel->category->EditCustomAttributes = "";
			$tbl_travel->category->EditValue = ew_HtmlEncode($tbl_travel->category->CurrentValue);

			// description
			$tbl_travel->description->EditCustomAttributes = "";
			$tbl_travel->description->EditValue = ew_HtmlEncode($tbl_travel->description->CurrentValue);
		}

		// Call Row Rendered event
		if ($tbl_travel->RowType <> EW_ROWTYPE_AGGREGATEINIT)
			$tbl_travel->Row_Rendered();
	}

	// Validate form
	function ValidateForm() {
		global $Language, $gsFormError, $tbl_travel;

		// Initialize form error message
		$gsFormError = "";
		if (!ew_CheckFileType($tbl_travel->photo->Upload->FileName)) {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $Language->Phrase("WrongFileType");
		}
		if ($tbl_travel->photo->Upload->FileSize > 0 && EW_MAX_FILE_SIZE > 0 && $tbl_travel->photo->Upload->FileSize > EW_MAX_FILE_SIZE) {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= str_replace("%s", EW_MAX_FILE_SIZE, $Language->Phrase("MaxFileSize"));
		}
		if (in_array($tbl_travel->photo->Upload->Error, array(1, 2, 3, 6, 7, 8))) {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $Language->Phrase("PhpUploadErr" . $tbl_travel->photo->Upload->Error);
		}

		// Check if validation required
		if (!EW_SERVER_VALIDATE)
			return ($gsFormError == "");
		if (!is_null($tbl_travel->travel_or_id->FormValue) && $tbl_travel->travel_or_id->FormValue == "") {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $Language->Phrase("EnterRequiredField") . " - " . $tbl_travel->travel_or_id->FldCaption();
		}
		if (is_null($tbl_travel->photo->Upload->Value)) {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $Language->Phrase("EnterRequiredField") . " - " . $tbl_travel->photo->FldCaption();
		}
		if (!is_null($tbl_travel->language_id->FormValue) && $tbl_travel->language_id->FormValue == "") {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $Language->Phrase("EnterRequiredField") . " - " . $tbl_travel->language_id->FldCaption();
		}
		if (!is_null($tbl_travel->category->FormValue) && $tbl_travel->category->FormValue == "") {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $Language->Phrase("EnterRequiredField") . " - " . $tbl_travel->category->FldCaption();
		}
		if (!is_null($tbl_travel->description->FormValue) && $tbl_travel->description->FormValue == "") {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $Language->Phrase("EnterRequiredField") . " - " . $tbl_travel->description->FldCaption();
		}

		// Return validate result
		$ValidateForm = ($gsFormError == "");

		// Call Form_CustomValidate event
		$sFormCustomError = "";
		$ValidateForm = $ValidateForm && $this->Form_CustomValidate($sFormCustomError);
		if ($sFormCustomError <> "") {
			$gsFormError .= ($gsFormError <> "") ? "<br>" : "";
			$gsFormError .= $sFormCustomError;
		}
		return $ValidateForm;
	}

	// Add record
	function AddRow() {
		global $conn, $Language, $Security, $tbl_travel;
		$rsnew = array();

		// travel_or_id
		$tbl_travel->travel_or_id->SetDbValueDef($rsnew, $tbl_travel->travel_or_id->CurrentValue, 0, FALSE);

		// photo
		$tbl_travel->photo->Upload->SaveToSession(); // Save file value to Session
		if (is_null($tbl_travel->photo->Upload->Value)) {
			$rsnew['photo'] = NULL;
		} else {
			$rsnew['photo'] = ew_UploadFileNameEx(ew_UploadPathEx(TRUE, $tbl_travel->photo->UploadPath), $tbl_travel->photo->Upload->FileName);
		}
		$tbl_travel->photo->ImageWidth = 221; // Resize width
		$tbl_travel->photo->ImageHeight = 130; // Resize height

		// language_id
		$tbl_travel->language_id->SetDbValueDef($rsnew, $tbl_travel->language_id->CurrentValue, 0, FALSE);

		// category
		$tbl_travel->category->SetDbValueDef($rsnew, $tbl_travel->category->CurrentValue, "", FALSE);

		// description
		$tbl_travel->description->SetDbValueDef($rsnew, $tbl_travel->description->CurrentValue, "", FALSE);

		// Call Row Inserting event
		$bInsertRow = $tbl_travel->Row_Inserting($rsnew);
		if ($bInsertRow) {
			if (!ew_Empty($tbl_travel->photo->Upload->Value)) {
				$tbl_travel->photo->Upload->RestoreFromSession(); // Restore original value
				$tbl_travel->photo->Upload->Resize($tbl_travel->photo->ImageWidth, $tbl_travel->photo->ImageHeight, 75);
			}
			$tbl_travel->photo->ImageWidth = 0; // Reset image width
			$tbl_travel->photo->ImageHeight = 0; // Reset image height
			if (!ew_Empty($tbl_travel->photo->Upload->Value)) {
				if ($tbl_travel->photo->Upload->FileName == $tbl_travel->photo->Upload->DbValue) { // Overwrite if same file name
					$tbl_travel->photo->Upload->SaveToFile($tbl_travel->photo->UploadPath, $rsnew['photo'], TRUE);
					$tbl_travel->photo->Upload->DbValue = ""; // No need to delete any more
				} else {
					$tbl_travel->photo->Upload->SaveToFile($tbl_travel->photo->UploadPath, $rsnew['photo'], FALSE);
				}
			}
			if ($tbl_travel->photo->Upload->Action == "2" || $tbl_travel->photo->Upload->Action == "3") { // Update/Remove
				if ($tbl_travel->photo->Upload->DbValue <> "")
					@unlink(ew_UploadPathEx(TRUE, $tbl_travel->photo->UploadPath) . $tbl_travel->photo->Upload->DbValue);
			}
			$conn->raiseErrorFn = 'ew_ErrorFn';
			$AddRow = $conn->Execute($tbl_travel->InsertSQL($rsnew));
			$conn->raiseErrorFn = '';
		} else {
			if ($tbl_travel->CancelMessage <> "") {
				$this->setMessage($tbl_travel->CancelMessage);
				$tbl_travel->CancelMessage = "";
			} else {
				$this->setMessage($Language->Phrase("InsertCancelled"));
			}
			$AddRow = FALSE;
		}
		if ($AddRow) {
			$tbl_travel->travel_id->setDbValue($conn->Insert_ID());
			$rsnew['travel_id'] = $tbl_travel->travel_id->DbValue;

			// Call Row Inserted event
			$tbl_travel->Row_Inserted($rsnew);
		}

		// photo
		$tbl_travel->photo->Upload->RemoveFromSession(); // Remove file value from Session
		return $AddRow;
	}

	// Set up master/detail based on QueryString
	function SetUpMasterDetail() {
		global $tbl_travel;
		$bValidMaster = FALSE;

		// Get the keys for master table
		if (@$_GET[EW_TABLE_SHOW_MASTER] <> "") {
			$sMasterTblVar = $_GET[EW_TABLE_SHOW_MASTER];
			if ($sMasterTblVar == "") {
				$bValidMaster = TRUE;
				$this->sDbMasterFilter = "";
				$this->sDbDetailFilter = "";
			}
			if ($sMasterTblVar == "tbl_language") {
				$bValidMaster = TRUE;
				$this->sDbMasterFilter = $tbl_travel->SqlMasterFilter_tbl_language();
				$this->sDbDetailFilter = $tbl_travel->SqlDetailFilter_tbl_language();
				if (@$_GET["language_id"] <> "") {
					$GLOBALS["tbl_language"]->language_id->setQueryStringValue($_GET["language_id"]);
					$tbl_travel->language_id->setQueryStringValue($GLOBALS["tbl_language"]->language_id->QueryStringValue);
					$tbl_travel->language_id->setSessionValue($tbl_travel->language_id->QueryStringValue);
					if (!is_numeric($GLOBALS["tbl_language"]->language_id->QueryStringValue)) $bValidMaster = FALSE;
					$this->sDbMasterFilter = str_replace("@language_id@", ew_AdjustSql($GLOBALS["tbl_language"]->language_id->QueryStringValue), $this->sDbMasterFilter);
					$this->sDbDetailFilter = str_replace("@language_id@", ew_AdjustSql($GLOBALS["tbl_language"]->language_id->QueryStringValue), $this->sDbDetailFilter);
				} else {
					$bValidMaster = FALSE;
				}
			}
			if ($sMasterTblVar == "tbl_travel_original") {
				$bValidMaster = TRUE;
				$this->sDbMasterFilter = $tbl_travel->SqlMasterFilter_tbl_travel_original();
				$this->sDbDetailFilter = $tbl_travel->SqlDetailFilter_tbl_travel_original();
				if (@$_GET["travel_or_id"] <> "") {
					$GLOBALS["tbl_travel_original"]->travel_or_id->setQueryStringValue($_GET["travel_or_id"]);
					$tbl_travel->travel_or_id->setQueryStringValue($GLOBALS["tbl_travel_original"]->travel_or_id->QueryStringValue);
					$tbl_travel->travel_or_id->setSessionValue($tbl_travel->travel_or_id->QueryStringValue);
					if (!is_numeric($GLOBALS["tbl_travel_original"]->travel_or_id->QueryStringValue)) $bValidMaster = FALSE;
					$this->sDbMasterFilter = str_replace("@travel_or_id@", ew_AdjustSql($GLOBALS["tbl_travel_original"]->travel_or_id->QueryStringValue), $this->sDbMasterFilter);
					$this->sDbDetailFilter = str_replace("@travel_or_id@", ew_AdjustSql($GLOBALS["tbl_travel_original"]->travel_or_id->QueryStringValue), $this->sDbDetailFilter);
				} else {
					$bValidMaster = FALSE;
				}
			}
		}
		if ($bValidMaster) {

			// Save current master table
			$tbl_travel->setCurrentMasterTable($sMasterTblVar);

			// Reset start record counter (new master key)
			$this->lStartRec = 1;
			$tbl_travel->setStartRecordNumber($this->lStartRec);
			$tbl_travel->setMasterFilter($this->sDbMasterFilter); // Set up master filter
			$tbl_travel->setDetailFilter($this->sDbDetailFilter); // Set up detail filter

			// Clear previous master key from Session
			if ($sMasterTblVar <> "tbl_language") {
				if ($tbl_travel->language_id->QueryStringValue == "") $tbl_travel->language_id->setSessionValue("");
			}
			if ($sMasterTblVar <> "tbl_travel_original") {
				if ($tbl_travel->travel_or_id->QueryStringValue == "") $tbl_travel->travel_or_id->setSessionValue("");
			}
		} else {
			$this->sDbMasterFilter = $tbl_travel->getMasterFilter(); //  Restore master filter
			$this->sDbDetailFilter = $tbl_travel->getDetailFilter(); // Restore detail filter
		}
	}

	// Page Load event
	function Page_Load() {

		//echo "Page Load";
	}

	// Page Unload event
	function Page_Unload() {

		//echo "Page Unload";
	}

	// Page Redirecting event
	function Page_Redirecting(&$url) {

		// Example:
		//$url = "your URL";

	}

	// Message Showing event
	function Message_Showing(&$msg) {

		// Example:
		//$msg = "your new message";

	}

	// Form Custom Validate event
	function Form_CustomValidate(&$CustomError) {

		// Return error message in CustomError
		return TRUE;
	}
}
?>
